/*
 * Copyright (c) 1996, 1997 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 *
 * This file is part of Flick, the Flexible IDL Compiler Kit.
 *
 * Flick is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Flick is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Flick; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place #330, Boston, MA 02111, USA.
 */

#ifndef _pg_fluke_hh
#define _pg_fluke_hh

#include <mom/c/pg_corba.hh>

extern "C" 
{
	mint_const build_op_const(aoi_interface *this_interface,
				  char *this_interface_name,
				  aoi_interface *derived_interface,
				  char *derived_interface_name,
				  aoi_operation *op,
				  int type_of_constant);
};

class pg_fluke : public pg_corba {
protected:
	
public:
	pg_fluke();
	
	/*****/
	
	virtual void      p_typedef_def(aoi_type at);
	virtual cast_type p_make_ctypename(aoi_ref ref);
	
	virtual void p_scalar(int bits, int is_signed, cast_type *out_ctype,
			      pres_c_mapping *out_map);
	virtual void p_float_type(aoi_float *ai, cast_type *out_ctype,
				  pres_c_mapping *out_map);
	virtual void p_char_type(aoi_char *ac, cast_type *out_ctype,
				 pres_c_mapping *out_map);
	virtual void p_enum_type(aoi_enum *ae, cast_type *out_ctype,
				 pres_c_mapping *out_map);
	virtual void p_interface_type(aoi_interface *ai,
				      cast_type *out_ctype,
				      pres_c_mapping *out_map);
	
	virtual void p_forward_type(cast_type *out_ctype,
				    pres_c_mapping *out_map);
	
	virtual void p_indirect_type(aoi_ref ref,
				     cast_type *out_ctype,
				     pres_c_mapping *out_map);
	
	virtual cast_type p_get_env_struct_type();
	virtual int p_get_exception_discrim();
	virtual int p_get_exception_void();
	virtual pres_c_inline_atom p_get_user_discrim();
	virtual void p_do_return_union(aoi_operation *ao,
				       pres_c_inline* reply_l4_inl,
				       mint_ref reply_ref,
				       cast_ref cfunc);
		
	/*****/
	
	virtual void p_param_type(aoi_type at, int mr,
				  aoi_direction dir,
				  cast_type *out_ctype,
				  pres_c_mapping *out_mapping);
	
	/*****/
	
	virtual void p_client_stub_special_params(aoi_operation *ao,
						  stub_special_params *s);
	virtual void p_server_func_special_params(aoi_operation *ao,
						  stub_special_params *s);
	
	virtual cast_ref p_server_skel_cdef(char *sskel_name);
	
	/*****/
	
	virtual void preprocess();
};

#endif // _pg_fluke_hh

/* End of file. */

