/*
 * Copyright (c) 1995, 1996, 1997 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 *
 * This file is part of Flick, the Flexible IDL Compiler Kit.
 *
 * Flick is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Flick is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Flick; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place #330, Boston, MA 02111, USA.
 */

#include <assert.h>

#include <mom/compiler.h>
#include <mom/Strings.h>

#include <mom/c/pg_corba.hh>

void pg_corba::preprocess()
{
	/*
	 * XXX --- All of this code should be unnecessary.
	 */
	
	// XXX --- Let the manual translation of attributes --> operations
	// continue until the PG library supports attributes in a more general
	// way.
	Strings get_pref("_get_"), set_pref("_set_");
	unsigned int a;
	
	for (a = 0; a < in_aoi->aoi_len; a++) {
		if (in_aoi->aoi_val[a].binding->kind == AOI_INTERFACE) {
			aoi_interface *interface = &(in_aoi->aoi_val[a].
						     binding->aoi_type_u_u.
						     interface_def);
			aoi_operation *ops = interface->ops.ops_val;
			
			interface->ops.ops_val 
				= (aoi_operation *)
				  mustcalloc((interface->ops.ops_len + 
					      interface->attribs.attribs_len
					      * 2) *
					     sizeof(aoi_operation));
			
			for(unsigned int temp = 0;
			    temp < interface->ops.ops_len;
			    temp++) 
				interface->ops.ops_val[temp] = ops[temp];
			
			for (unsigned int i = 0;
			     i < interface->attribs.attribs_len;
			     i++) {
				aoi_operation ao;
				aoi_attribute *aa = &(interface->attribs.
						      attribs_val[i]);
				Strings attrib_name(aa->name);
				
				ao.name = (char *) (get_pref + attrib_name);
				
				ao.request_code = aa->read_request_code;
				ao.reply_code = aa->read_reply_code;
				
				ao.flags = AOI_OP_FLAG_NONE;
				
				ao.params.params_len = 0;
				ao.params.params_val = 0;
				
				ao.return_type = aa->type;
				
				ao.exceps.exceps_len = 0;
				ao.exceps.exceps_val = 0;
				
				interface->ops.ops_val[interface->
						      ops.ops_len++] = ao;
				
				if (aa->readonly)
					continue;
				
				ao.name = (char *) (set_pref + attrib_name);
				
				ao.request_code = aa->write_request_code;
				ao.reply_code = aa->write_reply_code;
				
				ao.flags = AOI_OP_FLAG_NONE;
				
				ao.params.params_len = 1;
				ao.params.params_val =
					(aoi_parameter*)
					mustcalloc(sizeof(aoi_parameter));
				
				ao.params.params_val[0].name =
					(char *) attrib_name;
				ao.params.params_val[0].direction =
					AOI_DIR_IN;
				ao.params.params_val[0].type =
					aa->type;
				
				ao.return_type =
					(aoi_type)
					mustcalloc(sizeof(aoi_type_u));
				ao.return_type->kind = AOI_VOID;
				
				ao.exceps.exceps_len = 0;
				ao.exceps.exceps_val = 0;
				
				interface->ops.ops_val[interface->ops.
						      ops_len++] = ao;
			}
			
			interface->attribs.attribs_len = 0;
		}
	}
}

/* End of file. */

