/*
 * Copyright (c) 1996, 1997 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 *
 * This file is part of Flick, the Flexible IDL Compiler Kit.
 *
 * Flick is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Flick is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Flick; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place #330, Boston, MA 02111, USA.
 */

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include "ex-client.h"
#include <sys/time.h>

int main(int argc, char **argv)
{
	CLIENT tmp, *c;
	FLICK_SERVER_LOCATION s;
	int i;
	c = &tmp;
	if (argc != 2) {
		fprintf(stderr, "Usage: %s <host>\n", argv[0]);
		exit(1);
	}
	s.server_name = argv[1];
	s.prog_num = _PROG_A;
	s.vers_num = _VERS_A;
	create_client(c, s);
	printf("Beginning\n");
	
        for (i = 1; i <= 50000; i ++) {
		short val = i % 50;
		CORBA_Environment ev;
		short result = A_op(c, val, &ev);
		if (ev._major) {
			printf("Exception!!!  ev._major: %d\n", ev._major);
			printf("              Value:     %d\n", (int)((A_B *)ev._except)->a);
			CORBA_flick_free(ev._except);
			ev._major = 0;
		} else 
			printf("Result: %d\n", (int)result);
        }
	
	return 0;
}

/* End of file. */

