/*
 * Copyright (c) 1997 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 *
 * This file is part of Flick, the Flexible IDL Compiler Kit.
 *
 * Flick is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Flick is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Flick; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place #330, Boston, MA 02111, USA.
 */

#include <stdio.h>
#include <flick/link/suntcp.h>

#define MKFUNC(type, name)					\
type * ##name##_test_2345(type *arg, struct svc_req *o) {	\
	static type res;					\
	res = *arg;						\
	return &res;						\
}

void *void_test_2345(void *arg, struct svc_req *o) {
	static int res;
	return &res;
}

MKFUNC(char, char);
MKFUNC(int, bool);
MKFUNC(short, short);
MKFUNC(unsigned short, ushort);
MKFUNC(int, long);
MKFUNC(unsigned int, ulong);
MKFUNC(float, float);
MKFUNC(double, double);

/* End of file. */

